#! /usr/bin/env python

import sys
import string

lno=0                                   # current input line number
reclno=0                                # record starting line
lines = open("term.in").readlines()
driver1 = open("codes1.h","w")
driver2 = open("codes2.h","w")
keys = open("keys.h","w")
terminfo = open("jvterm.terminfo","w")

# removed "m" because broken programs may use ESC [ m as SGR
table="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklnopqrstuvwxyz@"
idx1=0
idx2=0
idx3=0

def get_cchar1():
    global idx1
    c=table[idx1]
    idx1 += 1
    return c
def get_cchar2():
    global idx2
    c=table[idx2]
    idx2 += 1
    return c
def get_kchar():
    global idx3
    c=table[idx3]
    idx3 += 1
    return c

def process(head,entry):
    l=head.strip().split(":")
    name = l[0]
    if len(l)>1:
        c = get_cchar2()
        args=int(l[1])
        for i in range(1,args+1):
            entry = entry.replace("ARG%d"%i, "(cd->par[%d])"%(i-1))

        driver2.write("    case '%s':\t/* %s */\n"%(c,name))
        # driver2.write('#line %d "term.in"\n'%reclno);
        driver2.write(entry.rstrip()+"\n")
        driver2.write("\tbreak;\n")

        argstr=";".join(map(lambda x: "%%p%d%%d"%x, range(1,args+1)))
        terminfo.write("\t%s=\\e[%s%c,\n"%(name,argstr,c));
    else:
        c = get_cchar1()

        driver1.write("    case '%s':\t/* %s */\n"%(c,name))
        # driver1.write('#line %d "term.in"\n'%reclno);
        driver1.write(entry.rstrip()+"\n")
        driver1.write("\tbreak;\n")

        terminfo.write("\t%s=\\e%c,\n"%(name,c));

def process_key(head):
    l=head.strip().split(":")
    sdl_name = l[1]
    name = l[2]
    c = get_kchar()

    keys.write("  case %s:\n"%sdl_name)
    keys.write("    if (keysym->mod&KMOD_ALT)  shell_send_char (scd, 27);\n")
    keys.write("    shell_send_char (scd, 27);\n")
    if len(l)>3:
        keys.write("    shell_send_char (scd, keysym->mod&KMOD_SHIFT?']':'[');\n")
    else:
        keys.write("    shell_send_char (scd, '[');\n")
    keys.write("    shell_send_char (scd, '%c');\n"%c)
    keys.write("    break;\n")

    terminfo.write("\t%s=\\e[%c,\n"%(name,c));
    if len(l)>3:
        terminfo.write("\t%s=\\e]%c,\n"%(l[3],c));

driver1.write("/* codes1.h - sniplet for console.c to implement all the control codes.\n")
driver1.write(" * DO NOT EDIT - autogenerated from term.in by the genterm.py script */\n\n")

driver2.write("/* codes2.h - sniplet for console.c to implement all the control codes.\n")
driver2.write(" * DO NOT EDIT - autogenerated from term.in by the genterm.py script */\n\n")

keys.write("/* keys.h sniplet for console.c to implement all the control codes.\n")
keys.write(" * DO NOT EDIT - autogenerated from term.in by the genterm.py script */\n\n")

terminfo.write("jvterm3|jvterm terminal emulator V3,\n")
terminfo.write("\tam,\n")
terminfo.write("\tacsc=++..\\,\\,--00``abffggiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz{{||}}~*,\n")
terminfo.write("\tbel=^G,\n")
terminfo.write("\tbw,\n")
terminfo.write("\tcolors#8,\n")
terminfo.write("\tcr=^M,\n")
terminfo.write("\tcub1=^H,\n")
terminfo.write("\tda,\n")
terminfo.write("\tht=^I,\n")
terminfo.write("\tit#8,\n")
terminfo.write("\tkbs=^?,\n")
terminfo.write("\tlm#0,\n")
terminfo.write("\tmsgr,\n")
terminfo.write("\tnel=^L,\n")
terminfo.write("\tpairs#64,\n")
terminfo.write("\tu8=^F,\n")            # make tack happy
terminfo.write("\tu9=^E,\n")            # make tack happy
terminfo.write("\txon,\n")

entry=""
for l in lines:
    lno += 1
    if l[0] == "#": continue
    if l.strip() == "": continue
    if l.strip() == "END": break
    if l.startswith("KEY:"):
        process_key(l)
    elif l[0] not in string.whitespace:
        if entry: process(head,entry)
        head=l
        entry=""
    else:
        if entry=="":
            reclno = lno
        entry += l
if entry: process(head,entry)

driver1.close()
driver2.close()
keys.close()

terminfo.write("\n")
terminfo.write("jvterm3-km|jvterm terminal emulator V3 with meta key,\n")
terminfo.write("\tkm,\n")
terminfo.write("\tuse=jvterm3,\n")
terminfo.close()
