/* test-font.c - test the character glyph subsystem
 *
 * Copyright (C) 2003  Jochen Voss.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 *
 * $Id: test-font.c 6725 2005-11-09 23:15:58Z voss $
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <jvrand.h>

#include "base.h"
#include "backend.h"


static  struct font_info  fi;


int
main ()
{
  struct charcell  cc;
  Uint32  t0, t1;
  int  i, k;

  if ((SDL_Init (SDL_INIT_VIDEO|SDL_INIT_TIMER) == -1)) {
    fatal_sdl ("Could not initialize SDL");
  }
  load_font (NULL, 12, &fi);

  puts ("test 1: getting the same glyph 1e7 times");
  cc.c = '@';
  cc.attr = 0;
  cc.colors = DEFAULT_COLOR;
  for (k=0; k<5; ++k) {
    t0 = SDL_GetTicks ();
    for (i=0; i<1e7; ++i) {
      SDL_Surface *glyph;
      glyph = font_get_glyph (&fi, cc);
    }
    t1 = SDL_GetTicks ();
    printf ("  %dms\n", t1-t0);
  }

  puts ("test 2: getting a random glyph 1e5 times");
  cc.c = '@';
  cc.attr = 0;
  cc.colors = DEFAULT_COLOR;
  for (k=0; k<5; ++k) {
    t0 = SDL_GetTicks ();
    for (i=0; i<1e5; ++i) {
      SDL_Surface *glyph;
      cc.c = jvrand_poisson (127);
      glyph = font_get_glyph (&fi, cc);
    }
    t1 = SDL_GetTicks ();
    printf ("  %dms\n", t1-t0);
  }
  
  unload_font ();
  SDL_Quit();

  return  0;
}
