#! /usr/bin/env python
# unicode.py - autogenerate a function to match combining characters
#
# Copyright (c) 2005  Jochen Voss  <voss@seehuhn.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#
# $Id: unicode.py 6694 2005-10-30 12:48:37Z voss $

fname="UnicodeData-4.0.1d1b.txt"

f=open("/usr/share/unidata/"+fname,"r")

start=None

codes=[]

for l in f.readlines():
    w=l.split(";")
    if w[2] not in ["Mc","Mn","Me"]: continue
    n=int(w[0],16)
    if n > 0xFFFF: continue

    codes.append(n)

def construct(n, a):
    tab=[0]*n
    for c in codes:
        x=(a*c)%n
        while tab[x]: x=(x+1)%n
        tab[x] = c
    return  tab

def stepit(runs,c):
    if c:
        runs[-1]+=1
    elif runs[-1]:
        runs.append(0)
    return  runs

def evaluate(tab):
    x=0
    while tab[x]: x+=1
    while not tab[x]: x=(x+1)%len(tab)

    runs = reduce (stepit, tab[x:]+tab[:x], [0])
    del runs[-1]
    #return max(runs)
    runs.sort()
    return (runs[len(runs)/2],runs[-1])

# f=file("d","w")
# bestmin=len(codes)
# bestn=len(codes)+1
# for n in range(len(codes)+1,len(codes)*3):
#     bestval=len(codes)
#     bestk=0
#     for k in range(1,n):
#         tab=construct(n,k)
#         val=evaluate(tab)
#         if val<bestval:
#             bestval=val
#             bestk=k
#     print n, bestk, bestval
#
#     if bestval<bestmin:
#         print >>f, n-1, bestmin
#         bestmin=bestval
#         bestn=n
#         print >>f, n, bestmin
#         f.flush()
# f.close()

n = 976
k = 66
tab=construct(n,k)
safe=(tab[-1]==0)

print "/* automatically generated from "+fname+" */"
print
print "static const Uint16 uc_combining_tab[%d] = {"%n
while tab:
    a=tab[0:8]
    del tab[0:8]
    line=", ".join(["0x%04X"%x for x in a])
    if tab: line += ","
    print "  "+line
print "};"

print """
int
char_is_combining (Uint16 n)
{
  unsigned  k = (n*%(k)d)%%%(n)d;
  while (1) {
    if (! uc_combining_tab[k])  return 0;
    if (uc_combining_tab[k] == n)  return 1;"""%{'k':k,'n':n}
if safe:
    print "    k += 1;"
else:
    print "    k = (k+1)%%%(n)d;"%{'k':k,'n':n}
print """  }
}"""%{'k':k,'n':n}
